Index: /palm/trunk/UTIL/inifor/src/grid.f90
===================================================================
--- /palm/trunk/UTIL/inifor/src/grid.f90	(revision 3394)
+++ /palm/trunk/UTIL/inifor/src/grid.f90	(revision 3395)
@@ -1291,4 +1386,177 @@
 
     END SUBROUTINE init_grid_definition
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Initializes averagin_grid-type variables.
+!> 
+!> Input parameters:
+!> -----------------
+!>
+!> cosmo_grid : grid_definition-type varieble initialized as 'cosmo-de' grid
+!>    providing longitudes and latitudes of the parent grid
+!>
+!> x, y : location of the profile to be averaged in the PALM system [m]
+!>
+!> z : vertical grid coordinates of the profile in the PALM system [m]
+!>
+!> <lat/lon><min/max>: boundaries of the averaging region in the parent system,
+!>    i.e. the COSMO-DE rotated-pole system. [rad]
+!>
+!> kind : kind of quantity to be averaged using this averaging grid.
+!>    Destinguishes COSMO-DE scalar and w-velocity levels. Note that finding the
+!>    parent/COSMO columns for the region in get_cosmo_averaging_region() is
+!>    independent of 'kind' b/ecause INIFOR uses column-centred u and v velocity
+!>    components, which are computed in the preprocessing step.
+!>
+!> Output parameters:
+!> ------------------
+!> avg_grid : averaging_grid variable to be initialized.
+!------------------------------------------------------------------------------!
+    SUBROUTINE init_averaging_grid(avg_grid, cosmo_grid, x, y, z, z0,          &
+       lonmin, lonmax, latmin, latmax, kind)
+
+       TYPE(grid_definition), INTENT(INOUT) ::  avg_grid
+       TYPE(grid_definition), INTENT(IN)    ::  cosmo_grid
+       REAL(dp), INTENT(IN)                 ::  x, y, z0
+       REAL(dp), INTENT(IN), TARGET         ::  z(:)
+       REAL(dp), INTENT(IN)                 ::  lonmin, lonmax, latmin, latmax
+
+       CHARACTER(LEN=*), INTENT(IN)         ::  kind
+
+       LOGICAL                              :: level_based_averaging
+
+       INTEGER :: i, j
+
+       ALLOCATE( avg_grid % x(1) )
+       ALLOCATE( avg_grid % y(1) )
+       avg_grid % x(1) = x
+       avg_grid % y(1) = y
+       avg_grid % z => z
+       avg_grid % z0 = z0
+
+       avg_grid % nz = SIZE(z, 1)
+
+       ALLOCATE( avg_grid % lon(2) )
+       ALLOCATE( avg_grid % lat(2) )
+       avg_grid % lon(1:2) = (/lonmin, lonmax/)
+       avg_grid % lat(1:2) = (/latmin, latmax/)
+
+       avg_grid % kind = TRIM(kind)
+
+       ! Find and store COSMO columns that fall into the coordinate range
+       ! given by avg_grid % clon, % clat
+       CALL get_cosmo_averaging_region(avg_grid, cosmo_grid)
+
+       ALLOCATE (avg_grid % kkk(avg_grid % n_columns, avg_grid % nz, 2) )
+       ALLOCATE (avg_grid % w(avg_grid % n_columns, avg_grid % nz, 2) )
+       ! Compute average COSMO levels in the averaging region
+       SELECT CASE(avg_grid % kind)
+
+       CASE('scalar', 'u', 'v')
+          avg_grid % cosmo_h => cosmo_grid % hfl
+
+       CASE('w')
+          avg_grid % cosmo_h => cosmo_grid % hhl
+
+       CASE DEFAULT
+          message = "Averaging grid kind '" // TRIM(avg_grid % kind) // &
+                    "' is not supported. Use 'scalar', 'u', or 'v'."
+          CALL abort('get_cosmo_averaging_region', message)
+
+       END SELECT
+
+       ! For level-besed averaging, compute average heights
+       level_based_averaging = .TRUE.
+       IF (level_based_averaging)  THEN
+          ALLOCATE(avg_grid % h(1,1,SIZE(avg_grid % cosmo_h, 3)) )
+ 
+          CALL average_2d(avg_grid % cosmo_h, avg_grid % h(1,1,:),                            &
+                          avg_grid % iii, avg_grid % jjj)
+       END IF
+
+       ! Copy averaged grid to all COSMO columnts, leads to computing the same
+       ! vertical interpolation weights for all columns and to COSMO grid level
+       ! based averaging onto the averaged COSMO heights.
+       IF ( TRIM(cfg % averaging_mode) == 'level' )  THEN
+          FORALL(                                                              &
+             i=1:SIZE(avg_grid % cosmo_h, 1),                                  &
+             j=1:SIZE(avg_grid % cosmo_h, 2)                                   &
+          )   avg_grid % cosmo_h(i,j,:) = avg_grid % h(1,1,:)
+       END IF
+
+       ! Compute vertical weights and neighbours
+       CALL find_vertical_neighbours_and_weights_average(avg_grid)
+
+    END SUBROUTINE init_averaging_grid
+
+
+    SUBROUTINE get_cosmo_averaging_region(avg_grid, cosmo_grid)
+       TYPE(grid_definition), INTENT(INOUT)         ::  avg_grid
+       TYPE(grid_definition), TARGET, INTENT(IN)    ::  cosmo_grid
+
+       REAL(dp), DIMENSION(:), POINTER              ::  cosmo_lon, cosmo_lat
+       REAL(dp)                                     ::  dlon, dlat
+
+       INTEGER ::  i, j, imin, imax, jmin, jmax, l, nx, ny
+
+
+       SELECT CASE( TRIM(avg_grid % kind) )
+
+       CASE('scalar', 'w')
+          cosmo_lon => cosmo_grid % lon
+          cosmo_lat => cosmo_grid % lat
+
+       CASE('u')
+          cosmo_lon => cosmo_grid % lonu
+          cosmo_lat => cosmo_grid % lat
+
+       CASE('v')
+          cosmo_lon => cosmo_grid % lon
+          cosmo_lat => cosmo_grid % latv
+
+       CASE DEFAULT
+          message = "Averaging grid kind '" // TRIM(avg_grid % kind) // &
+                    "' is not supported. Use 'scalar', 'u', or 'v'."
+          CALL abort('get_cosmo_averaging_region', message)
+
+       END SELECT
+
+
+       ! FIXME: make dlon, dlat parameters of the grid_defintion type
+       dlon = cosmo_lon(1) - cosmo_lon(0)
+       dlat = cosmo_lat(1) - cosmo_lat(0)
+
+       imin = CEILING( (avg_grid % lon(1) - cosmo_lon(0)) / dlon )
+       imax = FLOOR(   (avg_grid % lon(2) - cosmo_lon(0)) / dlon )
+
+       jmin = CEILING( (avg_grid % lat(1) - cosmo_lat(0)) / dlat )
+       jmax = FLOOR(   (avg_grid % lat(2) - cosmo_lat(0)) / dlat )
+       
+       message = "Averaging over "//                                           &
+                 TRIM(str(imin)) // " < i < " // TRIM(str(imax)) //            &
+                 " and " //                                                    &
+                 TRIM(str(jmin)) // " < j < " // TRIM(str(jmax))
+       CALL report( 'get_cosmo_averaging_region', message )
+
+       nx = imax - imin + 1
+       ny = jmax - jmin + 1
+       avg_grid % n_columns = nx * ny
+
+       ALLOCATE( avg_grid % iii(avg_grid % n_columns),                                 &
+                 avg_grid % jjj(avg_grid % n_columns) )
+
+       l = 0
+       DO j = jmin, jmax
+       DO i = imin, imax
+          l = l + 1
+          avg_grid % iii(l) = i
+          avg_grid % jjj(l) = j
+       END DO
+       END DO
+
+    END SUBROUTINE get_cosmo_averaging_region
 
 
@@ -1718,25 +1986,30 @@
        )
 
-       !potential temperature, surface pressure, including nudging and subsidence
+       !potential temperature, surface pressure, specific humidity including
+       !nudging and subsidence, and geostrophic winds ug, vg
        io_group_list(3) = init_io_group(                                       &
           in_files = flow_files,                                               &
-          out_vars = [output_var_table(3:8), output_var_table(42:42),          &
-                      output_var_table(49:51)],                                &
-          in_var_list = (/input_var_table(3), input_var_table(17)/),           &
-          kind = 'temperature'                                                 &
-       )
-
-       !specific humidity including nudging and subsidence
-       io_group_list(4) = init_io_group(                                       &
-          in_files = flow_files,                                               &
-          out_vars = [output_var_table(9:14), output_var_table(52:54)],        &
-          in_var_list = input_var_table(4:4),                                  &
-          kind = 'scalar'                                                      &
-       )
-
-       !u and v velocity and geostrophic winds ug, vg
+          out_vars = [output_var_table(56:64),                                 & ! internal averaged density and pressure profiles
+                      output_var_table(3:8), output_var_table(9:14),           &
+                      output_var_table(42:42), output_var_table(43:44),        &
+                      output_var_table(49:51), output_var_table(52:54)],       &
+          in_var_list = (/input_var_table(3), input_var_table(17),             & ! T, P, QV
+                          input_var_table(4) /),                               &
+          kind = 'thermodynamics',                                             &
+          n_output_quantities = 4                                              & ! P, Theta, Rho, qv
+       )
+
+       !Moved to therodynamic io_group
+       !io_group_list(4) = init_io_group(                                       &
+       !   in_files = flow_files,                                               &
+       !   out_vars = [output_var_table(9:14), output_var_table(52:54)],        &
+       !   in_var_list = input_var_table(4:4),                                  &
+       !   kind = 'scalar'                                                      &
+       !)
+
+       !u and v velocity, ug anv vg moved to thermodynamic io group. 
        io_group_list(5) = init_io_group(                                       &
           in_files = flow_files,                                               &
-          out_vars = [output_var_table(15:26), output_var_table(43:46)],       &
+          out_vars = [output_var_table(15:26), output_var_table(45:46)],       &
           !out_vars = output_var_table(15:20),                                  &
           in_var_list = input_var_table(5:6),                                  &
@@ -1845,9 +2118,11 @@
 
 
-    FUNCTION init_io_group(in_files, out_vars, in_var_list, kind) RESULT(group)
+    FUNCTION init_io_group(in_files, out_vars, in_var_list, kind,              &
+                           n_output_quantities) RESULT(group)
        CHARACTER(LEN=PATH), INTENT(IN) ::  in_files(:)
        CHARACTER(LEN=*), INTENT(IN)    ::  kind
        TYPE(nc_var), INTENT(IN)        ::  out_vars(:)
        TYPE(nc_var), INTENT(IN)        ::  in_var_list(:)
+       INTEGER, OPTIONAL               ::  n_output_quantities
 
        TYPE(io_group)                  ::  group
@@ -1855,7 +2130,14 @@
        group % nt = SIZE(in_files)
        group % nv = SIZE(out_vars)
+       group % n_inputs = SIZE(in_var_list)
        group % kind = TRIM(kind)
 
-       ALLOCATE(group % in_var_list( SIZE(in_var_list) ))
+       IF ( PRESENT(n_output_quantities) )  THEN
+          group % n_output_quantities = n_output_quantities
+       ELSE
+          group % n_output_quantities = group % n_inputs
+       END IF
+
+       ALLOCATE(group % in_var_list(group % n_inputs))
        ALLOCATE(group % in_files(group % nt))
        ALLOCATE(group % out_vars(group % nv))
@@ -1876,5 +2158,5 @@
     SUBROUTINE fini_grids()
 
-       CALL report('fini_grids', 'Deallocating grids')
+       CALL report('fini_grids', 'Deallocating grids', cfg % debug)
        
        DEALLOCATE(x, y, z, xu, yv, zw, z_column, zw_column)
@@ -1904,4 +2186,6 @@
     SUBROUTINE setup_variable_tables(ic_mode)
        CHARACTER(LEN=*), INTENT(IN) ::  ic_mode
+       INTEGER                      ::  n_invar = 0  !< number of variables in the input variable table
+       INTEGER                      ::  n_outvar = 0 !< number of variables in the output variable table
        TYPE(nc_var), POINTER        ::  var
 
@@ -1914,5 +2198,5 @@
 
        n_invar = 17
-       n_outvar = 55
+       n_outvar = 64
        ALLOCATE( input_var_table(n_invar) )
        ALLOCATE( output_var_table(n_outvar) )
@@ -2052,6 +2336,5 @@
        )
        IF (TRIM(ic_mode) == 'profile')  THEN
-          output_var_table(3) % grid => scalar_profile_grid
-          output_var_table(3) % intermediate_grid => scalar_profile_intermediate
+          output_var_table(3) % averaging_grid => averaged_scalar_profile
        END IF
 
@@ -2122,5 +2405,5 @@
           units             = "kg/kg",                                         &
           kind              = "init scalar",                                   &
-          input_id          = 1,                                               &
+          input_id          = 3,                                               &
           output_file       = output_file,                                     &
           grid              = palm_grid,                                       &
@@ -2129,6 +2412,5 @@
        )
        IF (TRIM(ic_mode) == 'profile')  THEN
-          output_var_table(9) % grid => scalar_profile_grid
-          output_var_table(9) % intermediate_grid => scalar_profile_intermediate
+          output_var_table(9) % averaging_grid => averaged_scalar_profile
        END IF
 
@@ -2139,5 +2421,5 @@
           units             = "kg/kg",                                         &
           kind              = "left scalar",                                   &
-          input_id          = 1,                                               &
+          input_id          = 3,                                               &
           output_file       = output_file,                                     &
           grid              = scalars_west_grid,                               &
@@ -2151,5 +2433,5 @@
           units             = "kg/kg",                                         &
           kind              = "right scalar",                                  &
-          input_id          = 1,                                               &
+          input_id          = 3,                                               &
           output_file       = output_file,                                     &
           grid              = scalars_east_grid,                               &
@@ -2163,5 +2445,5 @@
           units             = "kg/kg",                                         &
           kind              = "north scalar",                                  &
-          input_id          = 1,                                               &
+          input_id          = 3,                                               &
           output_file       = output_file,                                     &
           grid              = scalars_north_grid,                              &
@@ -2175,5 +2457,5 @@
           units             = "kg/kg",                                         &
           kind              = "south scalar",                                  &
-          input_id          = 1,                                               &
+          input_id          = 3,                                               &
           output_file       = output_file,                                     &
           grid              = scalars_south_grid,                              &
@@ -2187,5 +2469,5 @@
           units             = "kg/kg",                                         &
           kind              = "top scalar",                                    &
-          input_id          = 1,                                               &
+          input_id          = 3,                                               &
           output_file       = output_file,                                     &
           grid              = scalars_top_grid,                                &
@@ -2206,6 +2488,5 @@
        )
        IF (TRIM(ic_mode) == 'profile')  THEN
-          output_var_table(15) % grid => scalar_profile_grid
-          output_var_table(15) % intermediate_grid => scalar_profile_intermediate
+          output_var_table(15) % averaging_grid => averaged_scalar_profile
        END IF 
 
@@ -2283,6 +2564,5 @@
        )
        IF (TRIM(ic_mode) == 'profile')  THEN
-          output_var_table(21) % grid => scalar_profile_grid
-          output_var_table(21) % intermediate_grid => scalar_profile_intermediate
+          output_var_table(21) % averaging_grid => averaged_scalar_profile
        END IF
 
@@ -2360,6 +2640,5 @@
        )
        IF (TRIM(ic_mode) == 'profile')  THEN
-          output_var_table(27) % grid => w_profile_grid
-          output_var_table(27) % intermediate_grid => w_profile_intermediate
+          output_var_table(27) % averaging_grid => averaged_w_profile
        END IF
 
@@ -2546,4 +2825,5 @@
           intermediate_grid = palm_intermediate                                &
        )
+       output_var_table(42) % averaging_grid => averaged_scalar_profile
 
        output_var_table(43) = init_nc_var(                                     &
@@ -2552,9 +2832,9 @@
           long_name         = "geostrophic wind (u component)",                &
           units             = "m/s",                                           &
-          kind              = "constant scalar profile",                       &
+          kind              = "geostrophic",                                   &
           input_id          = 1,                                               &
           output_file       = output_file,                                     &
-          grid              = scalar_profile_grid,                             &
-          intermediate_grid = scalar_profile_intermediate                      &
+          grid              = averaged_scalar_profile,                         &
+          intermediate_grid = averaged_scalar_profile                          &
        )
 
@@ -2564,9 +2844,9 @@
           long_name         = "geostrophic wind (v component)",                &
           units             = "m/s",                                           &
-          kind              = "constant scalar profile",                       &
+          kind              = "geostrophic",                                   &
           input_id          = 1,                                               &
           output_file       = output_file,                                     &
-          grid              = scalar_profile_grid,                             &
-          intermediate_grid = scalar_profile_intermediate                      &
+          grid              = averaged_scalar_profile,                         &
+          intermediate_grid = averaged_scalar_profile                          &
        )
 
@@ -2576,9 +2856,9 @@
           long_name         = "wind component in x direction",                 &
           units             = "m/s",                                           &
-          kind              = "large-scale scalar forcing",                    &
+          kind              = "geostrophic",                                   &
           input_id          = 1,                                               &
           output_file       = output_file,                                     &
-          grid              = scalar_profile_grid,                             &
-          intermediate_grid = scalar_profile_intermediate                      &
+          grid              = averaged_scalar_profile,                         &
+          intermediate_grid = averaged_scalar_profile                          &
        )
        output_var_table(45) % to_be_processed = ls_forcing_variables_required
@@ -2592,6 +2872,6 @@
           input_id          = 1,                                               &
           output_file       = output_file,                                     &
-          grid              = scalar_profile_grid,                             &
-          intermediate_grid = scalar_profile_intermediate                      &
+          grid              = averaged_scalar_profile,                         &
+          intermediate_grid = averaged_scalar_profile                          &
        )
        output_var_table(46) % to_be_processed = ls_forcing_variables_required
@@ -2605,6 +2885,6 @@
           input_id          = 1,                                               &
           output_file       = output_file,                                     &
-          grid              = w_profile_grid,                                  &
-          intermediate_grid = w_profile_intermediate                           &
+          grid              = averaged_scalar_profile,                         &
+          intermediate_grid = averaged_scalar_profile                          &
        )
        output_var_table(47) % to_be_processed = ls_forcing_variables_required
@@ -2618,6 +2898,6 @@
           input_id          = 1,                                               &
           output_file       = output_file,                                     &
-          grid              = w_profile_grid,                                  &
-          intermediate_grid = w_profile_intermediate                           &
+          grid              = averaged_w_profile,                              &
+          intermediate_grid = averaged_w_profile                               &
        )
        output_var_table(48) % to_be_processed = ls_forcing_variables_required
@@ -2632,6 +2912,6 @@
           input_id          = 1,                                               &
           output_file       = output_file,                                     &
-          grid              = scalar_profile_grid,                             &
-          intermediate_grid = scalar_profile_intermediate                      &
+          grid              = averaged_scalar_profile,                         &
+          intermediate_grid = averaged_scalar_profile                          &
        )
        output_var_table(49) % to_be_processed = ls_forcing_variables_required
@@ -2645,6 +2925,6 @@
           input_id          = 1,                                               &
           output_file       = output_file,                                     &
-          grid              = scalar_profile_grid,                             &
-          intermediate_grid = scalar_profile_intermediate                      &
+          grid              = averaged_scalar_profile,                         &
+          intermediate_grid = averaged_scalar_profile                          &
        )
        output_var_table(50) % to_be_processed = ls_forcing_variables_required
@@ -2658,6 +2938,6 @@
           input_id          = 1,                                               &
           output_file       = output_file,                                     &
-          grid              = scalar_profile_grid,                             &
-          intermediate_grid = scalar_profile_intermediate                      &
+          grid              = averaged_scalar_profile,                         &
+          intermediate_grid = averaged_scalar_profile                          &
        )
        output_var_table(51) % to_be_processed = ls_forcing_variables_required
@@ -2669,8 +2949,8 @@
           units             = "kg/kg/s",                                       &
           kind              = "large-scale scalar forcing",                    &
-          input_id          = 1,                                               &
-          output_file       = output_file,                                     &
-          grid              = scalar_profile_grid,                             &
-          intermediate_grid = scalar_profile_intermediate                      &
+          input_id          = 3,                                               &
+          output_file       = output_file,                                     &
+          grid              = averaged_scalar_profile,                         &
+          intermediate_grid = averaged_scalar_profile                          &
        )
        output_var_table(52) % to_be_processed = ls_forcing_variables_required
@@ -2683,8 +2963,8 @@
           units             = "kg/kg/s",                                       &
           kind              = "large-scale scalar forcing",                    &
-          input_id          = 1,                                               &
-          output_file       = output_file,                                     &
-          grid              = scalar_profile_grid,                             &
-          intermediate_grid = scalar_profile_intermediate                      &
+          input_id          = 3,                                               &
+          output_file       = output_file,                                     &
+          grid              = averaged_scalar_profile,                         &
+          intermediate_grid = averaged_scalar_profile                          &
        )
        output_var_table(53) % to_be_processed = ls_forcing_variables_required
@@ -2696,8 +2976,8 @@
           units             = "kg/kg",                                         &
           kind              = "large-scale scalar forcing",                    &
-          input_id          = 1,                                               &
-          output_file       = output_file,                                     &
-          grid              = scalar_profile_grid,                             &
-          intermediate_grid = scalar_profile_intermediate                      &
+          input_id          = 3,                                               &
+          output_file       = output_file,                                     &
+          grid              = averaged_scalar_profile,                         &
+          intermediate_grid = averaged_scalar_profile                          &
        )
        output_var_table(54) % to_be_processed = ls_forcing_variables_required
